<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>CreateAndConfigureProject xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/library/transformations/CreateAndConfigureProject.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2016 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.library.transformations;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.StringTokenizer;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.resources.IProject;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.resources.IResource;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.resources.IWorkspaceRoot;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.resources.ResourcesPlugin;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.CoreException;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.NullProgressMonitor;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.profile.Deployment.DeploymentPlan;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.profile.Deployment.OperatingSystem;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.profile.Deployment.Target;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.tools.DepUtils;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.extensionpoints.AbstractSettings;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.extensionpoints.ILangProjectSupport;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.extensionpoints.LanguageProjectSupport;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.UIContext;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.CommandSupport;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.ProjectManagement;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.TransformationException;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.m2minterfaces.IM2MTrafoCDP;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.m2minterfaces.IM2MTrafoElem;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.ApplyRecursive;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.TransformationContext;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.library.Messages;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.profile.Transformation.M2MTrafo;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.PackageUtil;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Display;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InstanceSpecification;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.util.UMLUtil;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/library/transformations/CreateAndConfigureProject.html">CreateAndConfigureProject</a> <strong class="jxr_keyword">implements</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/m2minterfaces/IM2MTrafoCDP.html">IM2MTrafoCDP</a> {
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  	<strong class="jxr_keyword">protected</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/languages/common/extensionpoints/AbstractSettings.html">AbstractSettings</a> settings;
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  	<strong class="jxr_keyword">protected</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/languages/common/extensionpoints/ILangProjectSupport.html">ILangProjectSupport</a> projectSupport;
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  <em class="jxr_javadoccomment">	 * Gather configuration data for a code generation project In particular, a</em>
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <em class="jxr_javadoccomment">	 * class might be stereotyped to provide additional information about</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  <em class="jxr_javadoccomment">	 * required compilation options (in case of C++ include paths, libraries,</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <em class="jxr_javadoccomment">	 * ...)</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/library/transformations/CreateAndConfigureProject.html">GatherConfigData</a> <strong class="jxr_keyword">implements</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/m2minterfaces/IM2MTrafoElem.html">IM2MTrafoElem</a> {
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  		@Override
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  		<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> transformElement(<a href="../../../../../../../org/eclipse/papyrus/designer/transformation/profile/Transformation/M2MTrafo.html">M2MTrafo</a> trafo, Element element) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  			<strong class="jxr_keyword">if</strong> (element instanceof Classifier) {
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  				projectSupport.gatherConfigData((Classifier) element, settings);
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  			}
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  		}
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  	}
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  	<strong class="jxr_keyword">protected</strong> String getTargetOS(InstanceSpecification node) {
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  		Target target = UMLUtil.getStereotypeApplication(node, Target.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  		<strong class="jxr_keyword">if</strong> (target == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  			<em class="jxr_comment">// get information from node referenced by the instance</em>
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  			target = UMLUtil.getStereotypeApplication(DepUtils.getClassifier(node), Target.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  		}
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  		<strong class="jxr_keyword">if</strong> (target != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  			OperatingSystem os = target.getUsedOS();
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  			<strong class="jxr_keyword">if</strong> (os != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  				<strong class="jxr_keyword">return</strong> os.getBase_Class().getName();
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  			}
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  		}
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  	}
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  <em class="jxr_javadoccomment">	 * Get an existing or create a new project for a given language</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  <em class="jxr_javadoccomment">	 * @param projectSupport</em>
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  <em class="jxr_javadoccomment">	 *            project support instance (for a given programming language)</em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  <em class="jxr_javadoccomment">	 * @param projectName</em>
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  <em class="jxr_javadoccomment">	 *            the name of the project to create (or get, if it already</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  <em class="jxr_javadoccomment">	 *            exists)</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  <em class="jxr_javadoccomment">	 * @param targetLanguage</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  <em class="jxr_javadoccomment">	 * @param modelRoot</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  <em class="jxr_javadoccomment">	 * @return the project or null, if no project creation support is available</em>
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  <em class="jxr_javadoccomment">	 *         for the target language</em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> <em class="jxr_javadoccomment">	 * @throws TransformationException</em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 	<strong class="jxr_keyword">protected</strong> IProject getOrCreateProject(<a href="../../../../../../../org/eclipse/papyrus/designer/languages/common/extensionpoints/ILangProjectSupport.html">ILangProjectSupport</a> projectSupport, String projectName, String targetLanguage,
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 			Package modelRoot) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		IProject genProject = ProjectManagement.getNamedProject(projectName);
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		<strong class="jxr_keyword">if</strong> ((genProject == <strong class="jxr_keyword">null</strong>) || !genProject.exists()) {
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 			IWorkspaceRoot root = ResourcesPlugin.getWorkspace().getRoot();
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 			IProject[] projectsBeforeCreation = root.getProjects();
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 			genProject = projectSupport.createProject(projectName, modelRoot);
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 			<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 				root.refreshLocal(IResource.DEPTH_INFINITE, <strong class="jxr_keyword">new</strong> NullProgressMonitor());
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 				IProject[] projectsAfterCreation = root.getProjects();
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 				<strong class="jxr_keyword">boolean</strong> found = false;
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 				<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; projectsBeforeCreation.length; i++) {
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 					<strong class="jxr_keyword">if</strong> (!projectsAfterCreation[i].getName().equals(projectsBeforeCreation[i].getName())) {
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 						genProject = projectsAfterCreation[i];
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 						found = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 						<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 					}
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 				}
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 				<em class="jxr_comment">// The generated project is the last in the projects list in the</em>
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 				<em class="jxr_comment">// workspace</em>
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 				<strong class="jxr_keyword">if</strong> ((found == false) &amp;&amp; (projectsBeforeCreation.length &lt; projectsAfterCreation.length)) {
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 					genProject = projectsAfterCreation[projectsAfterCreation.length - 1];
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 				}
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 			} <strong class="jxr_keyword">catch</strong> (CoreException e) {
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 				e.printStackTrace();
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 			}
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 			<strong class="jxr_keyword">if</strong> ((genProject == <strong class="jxr_keyword">null</strong>) || !genProject.exists()) {
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 				<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> RuntimeException(<span class="jxr_string">"Could not create "</span> + targetLanguage <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 						+ <span class="jxr_string">" project. This might indicate that there is a problem with your "</span> + targetLanguage
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 						+ <span class="jxr_string">" installation."</span>);
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 			}
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 			<em class="jxr_comment">// project is new, force re-write of settings</em>
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 			UIContext.configureProject = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 		}
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 		<strong class="jxr_keyword">return</strong> genProject;
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 	}
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> <em class="jxr_javadoccomment">	 * Update the project name in the mapping (part of deployment plan). The object is to take a user decision into account</em>
<a class="jxr_linenumber" name="L143" href="#L143">143</a> <em class="jxr_javadoccomment">	 * to change the project name during project generation.</em>
<a class="jxr_linenumber" name="L144" href="#L144">144</a> <em class="jxr_javadoccomment">	 * @param genProject the generated project</em>
<a class="jxr_linenumber" name="L145" href="#L145">145</a> <em class="jxr_javadoccomment">	 * @param model the root model (used to calculate default project name)</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> <em class="jxr_javadoccomment">	 * @param node the deployment node</em>
<a class="jxr_linenumber" name="L147" href="#L147">147</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 	<strong class="jxr_keyword">void</strong> storeProjectName(<strong class="jxr_keyword">final</strong> IProject genProject, <strong class="jxr_keyword">final</strong> String defaultProjectName) {
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 		<strong class="jxr_keyword">if</strong> (genProject != <strong class="jxr_keyword">null</strong> &amp;&amp; TransformationContext.initialDeploymentPlan != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 			<strong class="jxr_keyword">final</strong> String pName = genProject.getName();
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 			<strong class="jxr_keyword">final</strong> Runnable storeProject = <strong class="jxr_keyword">new</strong> Runnable() {
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 				@Override
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 				<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> run() {
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 					Package deploymentPlanElement = TransformationContext.initialDeploymentPlan;
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 					DeploymentPlan deploymentPlan = UMLUtil.getStereotypeApplication(deploymentPlanElement,
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 							DeploymentPlan.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 					EList&lt;String&gt; projectMappings = deploymentPlan.getProjectMappings();
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 					String newMapping = defaultProjectName + <span class="jxr_string">"="</span> + pName;
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 					<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> j = 0; j &lt; projectMappings.size(); j++) {
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 						StringTokenizer str = <strong class="jxr_keyword">new</strong> StringTokenizer(projectMappings.get(j), <span class="jxr_string">"="</span>);
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 						String genName = str.nextToken();
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 						<strong class="jxr_keyword">if</strong> (genName.equals(defaultProjectName)) {
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 							projectMappings.remove(j);
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 							<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 						}
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 					}
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 					projectMappings.add(newMapping);
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 				}
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 			};
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 			<em class="jxr_comment">// command must be run in UI thread, otherwise subsequent updates of Papyrus widgets will raise an SWT exception</em>
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 			Runnable storeProjectCmd = <strong class="jxr_keyword">new</strong> Runnable() {
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 				@Override
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 				<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> run() {
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 					CommandSupport.exec(TransformationContext.initialDeploymentPlan, <span class="jxr_string">"Change Project Mapping"</span>, storeProject);
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 				}
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 			};
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 			Display.getDefault().asyncExec(storeProjectCmd);
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 		}
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 	}
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L184" href="#L184">184</a> <em class="jxr_javadoccomment">	 * Return the name of a project that is associated with a model that is</em>
<a class="jxr_linenumber" name="L185" href="#L185">185</a> <em class="jxr_javadoccomment">	 * deployed on a node (in the context of a deployment plan). The function</em>
<a class="jxr_linenumber" name="L186" href="#L186">186</a> <em class="jxr_javadoccomment">	 * takes a user defined project name into account</em>
<a class="jxr_linenumber" name="L187" href="#L187">187</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L188" href="#L188">188</a> <em class="jxr_javadoccomment">	 * @param model</em>
<a class="jxr_linenumber" name="L189" href="#L189">189</a> <em class="jxr_javadoccomment">	 *            The model that is deployed</em>
<a class="jxr_linenumber" name="L190" href="#L190">190</a> <em class="jxr_javadoccomment">	 * @param node</em>
<a class="jxr_linenumber" name="L191" href="#L191">191</a> <em class="jxr_javadoccomment">	 *            The node onto which the software is deployed</em>
<a class="jxr_linenumber" name="L192" href="#L192">192</a> <em class="jxr_javadoccomment">	 * @return The resulting project name</em>
<a class="jxr_linenumber" name="L193" href="#L193">193</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 	<strong class="jxr_keyword">public</strong> String getProjectName(Package model, InstanceSpecification node) {
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 		String projectName = model.getName() + <span class="jxr_string">"_"</span> + node.getName(); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 		projectName += <span class="jxr_string">"_"</span> + TransformationContext.current.deploymentPlan.getName(); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 		DeploymentPlan depPlan = UMLUtil.getStereotypeApplication(TransformationContext.current.deploymentPlan,
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 				DeploymentPlan.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 		<strong class="jxr_keyword">if</strong> (depPlan != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 			<strong class="jxr_keyword">for</strong> (String mapping : depPlan.getProjectMappings()) {
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 				<strong class="jxr_keyword">if</strong> (mapping.startsWith(projectName)) {
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 					<strong class="jxr_keyword">int</strong> index = mapping.indexOf(<span class="jxr_string">"="</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 					<strong class="jxr_keyword">if</strong> (index != -1) {
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 						<strong class="jxr_keyword">return</strong> mapping.substring(index + 1);
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 					}
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 				}
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 			}
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 		}
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 		<strong class="jxr_keyword">return</strong> projectName;
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 	}
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L213" href="#L213">213</a> <em class="jxr_javadoccomment">	 * Return the default name of a project deployment on a node (in the context of a deployment plan)</em>
<a class="jxr_linenumber" name="L214" href="#L214">214</a> <em class="jxr_javadoccomment">	 * @param model</em>
<a class="jxr_linenumber" name="L215" href="#L215">215</a> <em class="jxr_javadoccomment">	 *            The model that is deployed</em>
<a class="jxr_linenumber" name="L216" href="#L216">216</a> <em class="jxr_javadoccomment">	 * @param node</em>
<a class="jxr_linenumber" name="L217" href="#L217">217</a> <em class="jxr_javadoccomment">	 *            The node onto which the software is deployed</em>
<a class="jxr_linenumber" name="L218" href="#L218">218</a> <em class="jxr_javadoccomment">	 * @return The resulting project name</em>
<a class="jxr_linenumber" name="L219" href="#L219">219</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 	<strong class="jxr_keyword">public</strong> String getDefaultProjectName(Package model, InstanceSpecification node) {
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 		String projectName = model.getName() + <span class="jxr_string">"_"</span> + node.getName(); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 		projectName += <span class="jxr_string">"_"</span> + TransformationContext.current.deploymentPlan.getName(); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 		<strong class="jxr_keyword">return</strong> projectName;
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 	}
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 	@Override
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> applyTrafo(<a href="../../../../../../../org/eclipse/papyrus/designer/transformation/profile/Transformation/M2MTrafo.html">M2MTrafo</a> trafo, Package deploymentPlan) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 		TransformationContext tc = TransformationContext.current;
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 		EList&lt;InstanceSpecification&gt; topLevelInstances = <a href="../../../../../../../org/eclipse/papyrus/designer/deployment/tools/DepUtils.html">DepUtils</a>
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 				.getTopLevelInstances(TransformationContext.current.deploymentPlan);
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 		<em class="jxr_comment">// get first language (restricted to single target language,</em>
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 		<em class="jxr_comment">// acceptable?)</em>
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 		String targetLanguage = DepUtils.getTargetLanguage(topLevelInstances.iterator().next());
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 		String projectName = getProjectName(tc.modelRoot, tc.node);
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 		projectSupport = LanguageProjectSupport.getProjectSupport(targetLanguage);
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 		IProject genProject = getOrCreateProject(projectSupport, projectName, targetLanguage, tc.deploymentPlan);
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 		<strong class="jxr_keyword">if</strong> (genProject == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/base/utils/TransformationException.html">TransformationException</a>(
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 					String.format(Messages.DeployToNodes_CouldNotCreateProject, targetLanguage));
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 		}
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 		<strong class="jxr_keyword">if</strong> (!genProject.getName().equals(projectName)) {
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 			<em class="jxr_comment">// if name has been changed during project creation, the new name should be stored in the project mappings</em>
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 			storeProjectName(genProject, getDefaultProjectName(tc.modelRoot, tc.node));
<a class="jxr_linenumber" name="L245" href="#L245">245</a> 		}
<a class="jxr_linenumber" name="L246" href="#L246">246</a> 
<a class="jxr_linenumber" name="L247" href="#L247">247</a> 		tc.projectSupport = projectSupport;
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 		tc.project = genProject;
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 		<strong class="jxr_keyword">if</strong> (UIContext.configureProject) {
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 			GatherConfigData gatherData = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/library/transformations/CreateAndConfigureProject.html">GatherConfigData</a>();
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 			settings = projectSupport.initialConfigurationData();
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 			<strong class="jxr_keyword">if</strong> (settings != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 				settings.targetOS = getTargetOS(TransformationContext.current.node);
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 			}
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 			ApplyRecursive ar = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/transformations/ApplyRecursive.html">ApplyRecursive</a>(trafo, gatherData);
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 			ar.applyRecursive(PackageUtil.getRootPackage(deploymentPlan));
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 			projectSupport.setSettings(TransformationContext.current.project, settings);
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 		}
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 	}
<a class="jxr_linenumber" name="L261" href="#L261">261</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
